"""
Autogenerated module using `pop-create-idem <https://gitlab.com/saltstack/pop/pop-create-idem>`__
"""


async def esx_config(hub, ctx, org: str, sddc: str, action: str = None) -> None:
    """
    **Autogenerated function**
    
    Args:
        org(str): Organization identifier.
        sddc(str): Sddc identifier.
        action(str, optional): If = 'add', will add the esx.
If = 'remove', will delete the esx/esxs bound to a single cluster (Cluster Id is mandatory for non cluster 1 esx remove).
If = 'force-remove', will delete the esx even if it can lead to data loss (This is an privileged operation).
If = 'addToAll', will add esxs to all clusters in the SDDC (This is an privileged operation).
If = 'removeFromAll', will delete the esxs from all clusters in the SDDC (This is an privileged operation).
If = 'attach-diskgroup', will attach the provided diskgroups to a given host (privileged).
If = 'detach-diskgroup', will detach the diskgroups of a given host (privileged).
Default behaviour is 'add'
. Defaults to None.

    Returns:
        None

    Examples:
        Call from code:

        .. code-block:: python

            await hub.exec.vmc.sddc.esx.esx_config(ctx, org=value, sddc=value)

        Call from CLI:

        .. code-block:: bash

            idem exec vmc.sddc.esx.esx_config org=value, sddc=value
    """

    return await hub.tool.http.session.request(
        ctx,
        method="post",
        path=ctx.acct.endpoint_url + "/orgs/{org}/sddcs/{sddc}/esxs".format(**{"org": org, "sddc": sddc}),
        query_params={"action": action},
        data={}
    )

